<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_60) on Tue Apr 26 16:24:20 CEST 2016 -->
<title>JSONWriter</title>
<meta name="date" content="2016-04-26">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="JSONWriter";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/JSONWriter.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../aasbo/json/JSONTokener.html" title="class in aasbo.json"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../aasbo/json/Property.html" title="class in aasbo.json"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?aasbo/json/JSONWriter.html" target="_top">Frames</a></li>
<li><a href="JSONWriter.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">aasbo.json</div>
<h2 title="Class JSONWriter" class="title">Class JSONWriter</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>aasbo.json.JSONWriter</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><a href="../../aasbo/json/JSONStringer.html" title="class in aasbo.json">JSONStringer</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">JSONWriter</span>
extends java.lang.Object</pre>
<div class="block">JSONWriter provides a quick and convenient way of producing JSON text.
 The texts produced strictly conform to JSON syntax rules. No whitespace is
 added, so the results are ready for transmission or storage. Each instance of
 JSONWriter can produce one JSON text.
 <p>
 A JSONWriter instance provides a <code>value</code> method for appending
 values to the
 text, and a <code>key</code>
 method for adding keys before values in objects. There are <code>array</code>
 and <code>endArray</code> methods that make and bound array values, and
 <code>object</code> and <code>endObject</code> methods which make and bound
 object values. All of these methods return the JSONWriter instance,
 permitting a cascade style. For example, <pre>
 new JSONWriter(myWriter)
     .object()
         .key("JSON")
         .value("Hello, World!")
     .endObject();</pre> which writes <pre>
 {"JSON":"Hello, World!"}</pre>
 <p>
 The first method called must be <code>array</code> or <code>object</code>.
 There are no methods for adding commas or colons. JSONWriter adds them for
 you. Objects and arrays can be nested up to 20 levels deep.
 <p>
 This can sometimes be easier than using a JSONObject to build a string.</div>
<dl>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>2015-12-09</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>JSON.org</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#comma">comma</a></span></code>
<div class="block">The comma flag determines if a comma should be output before the next
 value.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#maxdepth">maxdepth</a></span></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected char</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#mode">mode</a></span></code>
<div class="block">The current mode.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../aasbo/json/JSONObject.html" title="class in aasbo.json">JSONObject</a>[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#stack">stack</a></span></code>
<div class="block">The object/array stack.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#top">top</a></span></code>
<div class="block">The stack top index.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected java.io.Writer</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#writer">writer</a></span></code>
<div class="block">The writer that will receive the output.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#JSONWriter-java.io.Writer-">JSONWriter</a></span>(java.io.Writer&nbsp;w)</code>
<div class="block">Make a fresh JSONWriter.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>private <a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#append-java.lang.String-">append</a></span>(java.lang.String&nbsp;string)</code>
<div class="block">Append a value.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code><a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#array--">array</a></span>()</code>
<div class="block">Begin appending a new array.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>private <a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#end-char-char-">end</a></span>(char&nbsp;mode,
   char&nbsp;c)</code>
<div class="block">End something.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code><a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#endArray--">endArray</a></span>()</code>
<div class="block">End an array.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code><a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#endObject--">endObject</a></span>()</code>
<div class="block">End an object.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#key-java.lang.String-">key</a></span>(java.lang.String&nbsp;string)</code>
<div class="block">Append a key.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code><a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#object--">object</a></span>()</code>
<div class="block">Begin appending a new object.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#pop-char-">pop</a></span>(char&nbsp;c)</code>
<div class="block">Pop an array or object scope.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#push-aasbo.json.JSONObject-">push</a></span>(<a href="../../aasbo/json/JSONObject.html" title="class in aasbo.json">JSONObject</a>&nbsp;jo)</code>
<div class="block">Push an array or object scope.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code><a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#value-boolean-">value</a></span>(boolean&nbsp;b)</code>
<div class="block">Append either the value <code>true</code> or the value
 <code>false</code>.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code><a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#value-double-">value</a></span>(double&nbsp;d)</code>
<div class="block">Append a double value.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code><a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#value-long-">value</a></span>(long&nbsp;l)</code>
<div class="block">Append a long value.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code><a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../aasbo/json/JSONWriter.html#value-java.lang.Object-">value</a></span>(java.lang.Object&nbsp;object)</code>
<div class="block">Append an object value.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="maxdepth">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>maxdepth</h4>
<pre>private static final&nbsp;int maxdepth</pre>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../constant-values.html#aasbo.json.JSONWriter.maxdepth">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="comma">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>comma</h4>
<pre>private&nbsp;boolean comma</pre>
<div class="block">The comma flag determines if a comma should be output before the next
 value.</div>
</li>
</ul>
<a name="mode">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>mode</h4>
<pre>protected&nbsp;char mode</pre>
<div class="block">The current mode. Values:
 'a' (array),
 'd' (done),
 'i' (initial),
 'k' (key),
 'o' (object).</div>
</li>
</ul>
<a name="stack">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>stack</h4>
<pre>private final&nbsp;<a href="../../aasbo/json/JSONObject.html" title="class in aasbo.json">JSONObject</a>[] stack</pre>
<div class="block">The object/array stack.</div>
</li>
</ul>
<a name="top">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>top</h4>
<pre>private&nbsp;int top</pre>
<div class="block">The stack top index. A value of 0 indicates that the stack is empty.</div>
</li>
</ul>
<a name="writer">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>writer</h4>
<pre>protected&nbsp;java.io.Writer writer</pre>
<div class="block">The writer that will receive the output.</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="JSONWriter-java.io.Writer-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>JSONWriter</h4>
<pre>public&nbsp;JSONWriter(java.io.Writer&nbsp;w)</pre>
<div class="block">Make a fresh JSONWriter. It can be used to build one JSON text.</div>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="append-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>append</h4>
<pre>private&nbsp;<a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a>&nbsp;append(java.lang.String&nbsp;string)
                   throws <a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></pre>
<div class="block">Append a value.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>string</code> - A string value.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></code> - If the value is out of sequence.</dd>
</dl>
</li>
</ul>
<a name="array--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>array</h4>
<pre>public&nbsp;<a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a>&nbsp;array()
                 throws <a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></pre>
<div class="block">Begin appending a new array. All values until the balancing
 <code>endArray</code> will be appended to this array. The
 <code>endArray</code> method must be called to mark the array's end.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></code> - If the nesting is too deep, or if the object is
 started in the wrong place (for example as a key or after the end of the
 outermost array or object).</dd>
</dl>
</li>
</ul>
<a name="end-char-char-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>end</h4>
<pre>private&nbsp;<a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a>&nbsp;end(char&nbsp;mode,
                       char&nbsp;c)
                throws <a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></pre>
<div class="block">End something.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>mode</code> - Mode</dd>
<dd><code>c</code> - Closing character</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></code> - If unbalanced.</dd>
</dl>
</li>
</ul>
<a name="endArray--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>endArray</h4>
<pre>public&nbsp;<a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a>&nbsp;endArray()
                    throws <a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></pre>
<div class="block">End an array. This method most be called to balance calls to
 <code>array</code>.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></code> - If incorrectly nested.</dd>
</dl>
</li>
</ul>
<a name="endObject--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>endObject</h4>
<pre>public&nbsp;<a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a>&nbsp;endObject()
                     throws <a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></pre>
<div class="block">End an object. This method most be called to balance calls to
 <code>object</code>.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></code> - If incorrectly nested.</dd>
</dl>
</li>
</ul>
<a name="key-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>key</h4>
<pre>public&nbsp;<a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a>&nbsp;key(java.lang.String&nbsp;string)
               throws <a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></pre>
<div class="block">Append a key. The key will be associated with the next value. In an
 object, every value must be preceded by a key.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>string</code> - A key string.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></code> - If the key is out of place. For example, keys
  do not belong in arrays or if the key is null.</dd>
</dl>
</li>
</ul>
<a name="object--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>object</h4>
<pre>public&nbsp;<a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a>&nbsp;object()
                  throws <a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></pre>
<div class="block">Begin appending a new object. All keys and values until the balancing
 <code>endObject</code> will be appended to this object. The
 <code>endObject</code> method must be called to mark the object's end.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></code> - If the nesting is too deep, or if the object is
 started in the wrong place (for example as a key or after the end of the
 outermost array or object).</dd>
</dl>
</li>
</ul>
<a name="pop-char-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>pop</h4>
<pre>private&nbsp;void&nbsp;pop(char&nbsp;c)
          throws <a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></pre>
<div class="block">Pop an array or object scope.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>c</code> - The scope to close.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></code> - If nesting is wrong.</dd>
</dl>
</li>
</ul>
<a name="push-aasbo.json.JSONObject-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>push</h4>
<pre>private&nbsp;void&nbsp;push(<a href="../../aasbo/json/JSONObject.html" title="class in aasbo.json">JSONObject</a>&nbsp;jo)
           throws <a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></pre>
<div class="block">Push an array or object scope.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jo</code> - The scope to open.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></code> - If nesting is too deep.</dd>
</dl>
</li>
</ul>
<a name="value-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>value</h4>
<pre>public&nbsp;<a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a>&nbsp;value(boolean&nbsp;b)
                 throws <a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></pre>
<div class="block">Append either the value <code>true</code> or the value
 <code>false</code>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>b</code> - A boolean.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></code></dd>
</dl>
</li>
</ul>
<a name="value-double-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>value</h4>
<pre>public&nbsp;<a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a>&nbsp;value(double&nbsp;d)
                 throws <a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></pre>
<div class="block">Append a double value.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>d</code> - A double.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></code> - If the number is not finite.</dd>
</dl>
</li>
</ul>
<a name="value-long-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>value</h4>
<pre>public&nbsp;<a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a>&nbsp;value(long&nbsp;l)
                 throws <a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></pre>
<div class="block">Append a long value.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>l</code> - A long.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></code></dd>
</dl>
</li>
</ul>
<a name="value-java.lang.Object-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>value</h4>
<pre>public&nbsp;<a href="../../aasbo/json/JSONWriter.html" title="class in aasbo.json">JSONWriter</a>&nbsp;value(java.lang.Object&nbsp;object)
                 throws <a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></pre>
<div class="block">Append an object value.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>object</code> - The object to append. It can be null, or a Boolean, Number,
   String, JSONObject, or JSONArray, or an object that implements JSONString.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../aasbo/json/JSONException.html" title="class in aasbo.json">JSONException</a></code> - If the value is out of sequence.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/JSONWriter.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../aasbo/json/JSONTokener.html" title="class in aasbo.json"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../aasbo/json/Property.html" title="class in aasbo.json"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?aasbo/json/JSONWriter.html" target="_top">Frames</a></li>
<li><a href="JSONWriter.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
